Module Module1

  Sub Main()
    Dim nNumVars As Integer = 3
    Dim fX() As Double = {3, 2, 1}
    Dim fParam() As Double = {0, 0, 0}
    Dim fToler() As Double = {0.00000001, 0.00000001, 0.00000001}
    Dim nIter As Integer = 0
    Dim nMaxIter As Integer = 500
    Dim fEpsFx As Double = 0.0000001
    Dim I As Integer
    Dim sAnswer As String
    Dim oRoot As CRoots_NLE_Newton1
    Dim MyFx As MyFxDelegate = AddressOf Fx1
    Dim SayFx As SayFxDelegate = AddressOf SayFx1

    oRoot = New CRoots_NLE_Newton1

    Console.WriteLine("Newton's method for finding the roots of simultaneous nonlinear equations")
    Console.WriteLine("Finding the roots of functions:")
    Console.WriteLine(SayFx())
    Console.Write("Use default input values? (Y/N) ")
    sAnswer = Console.ReadLine()
    If sAnswer.ToUpper() = "Y" Then
      For I = 0 To nNumVars - 1
        Console.WriteLine("X({0}) = {1}", I + 1, fX(I))
        Console.WriteLine("Tolerance({0}) = {1}", I + 1, fToler(I))
      Next
      Console.WriteLine("Function tolerance = {0}", fEpsFx)
      Console.WriteLine("Maxumum cycles = {0}", nMaxIter)
    Else
      For I = 0 To nNumVars - 1
        fX(I) = GetIndexedDblInput("X", I + 1, fX(I))
        fToler(I) = GetIndexedDblInput("Tolerance", I + 1, fToler(I))
      Next
      fEpsFx = GetIntInput("Function tolerance", fEpsFx)
      nMaxIter = GetDblInput("Maxumum cycles", nMaxIter)
    End If

    Console.WriteLine("******** FINAL RESULTS *************")
    oRoot.CalcRoots(nNumVars, fX, fParam, fToler, fEpsFx, nMaxIter, nIter, MyFx)
    Console.WriteLine("Optimum at")
    For I = 0 To nNumVars - 1
      Console.WriteLine("X({0}) = {1}", I + 1, fX(I))
    Next
    Console.WriteLine("Number of iterations = {0}", nIter)
    Console.WriteLine()
    Console.Write("Press Enter to end the program ...")
    Console.ReadLine()
  End Sub

  Function GetDblInput(ByVal sPrompt As String, ByVal fDefInput As Double) As Double
    Dim sInput As String

    Console.Write("{0}? ({1}): ", sPrompt, fDefInput)
    sInput = Console.ReadLine()
    If sInput.Trim().Length > 0 Then
      Return Double.Parse(sInput)
    Else
      Return fDefInput
    End If
  End Function

  Function GetIntInput(ByVal sPrompt As String, ByVal nDefInput As Integer) As Integer
    Dim sInput As String

    Console.Write("{0}? ({1}): ", sPrompt, nDefInput)
    sInput = Console.ReadLine()
    If sInput.Trim().Length > 0 Then
      Return Double.Parse(sInput)
    Else
      Return nDefInput
    End If
  End Function

  Function GetIndexedDblInput(ByVal sPrompt As String, ByVal nIndex As Integer, ByVal fDefInput As Double) As Double
    Dim sInput As String

    Console.Write("{0}({1})? ({2}): ", sPrompt, nIndex, fDefInput)
    sInput = Console.ReadLine()
    If sInput.Trim().Length > 0 Then
      Return Double.Parse(sInput)
    Else
      Return fDefInput
    End If
  End Function

  Function GetIndexedIntInput(ByVal sPrompt As String, ByVal nIndex As Integer, ByVal nDefInput As Integer) As Integer
    Dim sInput As String

    Console.Write("{0}({1})? ({2}): ", sPrompt, nIndex, nDefInput)
    sInput = Console.ReadLine()
    If sInput.Trim().Length > 0 Then
      Return Double.Parse(sInput)
    Else
      Return nDefInput
    End If
  End Function

  Function SayFx1() As String
    Return "F1(X) = X(1) * X(2) * X(3) - 6" & vbCrLf & _
            "F2(X) = X(1) + x(2)) / X(3) - 1" & vbCrLf & _
            "F3(X) = X(1) + 1) * x(2) - x(3) - 1"
  End Function

  Function Fx1(ByVal N As Integer, ByRef X() As Double, ByRef fParam() As Double, ByVal nVarIndex As Integer) As Double
    Select Case nVarIndex
      Case 1
        Return X(0) * X(1) * X(2) - 6
      Case 2
        Return (X(0) + X(1)) / X(2) - 1
      Case Else ' case 3
        Return (X(0) + 1) * X(1) - X(2) - 1
    End Select
  End Function

End Module




